﻿Imports System
Imports System.Threading
Imports System.IO.Ports
Imports System.ComponentModel
Public Class Form1
    Dim myPort As Array
    Dim valuehex As String
    Dim x280 As String

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        'wenn Form geschlossen wird
        If SerialPort1.IsOpen Then                      'abfragen ob Serial Port geöffnet ist
            SerialPort1.Write("C" & vbCr)               'CAN Channal schließen
            Thread.Sleep(50)                            '50ms warten
            SerialPort1.Close()                         'Serial Port schließen
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        myPort = IO.Ports.SerialPort.GetPortNames()     'Array mit den COM Ports füllen
        ComboBox1.Items.AddRange(myPort)                'Array in Combo Box laden
        Timer1.Start()                                  'Timer 1 Starten
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'open Button
        Try
            SerialPort1.PortName = ComboBox1.SelectedItem
            SerialPort1.Open()                          'Serial Port 1 öffnen
            Button2.Enabled = True
            Button1.Enabled = False
            TrackBar1.Enabled = True
            SerialPort1.Write("C" & vbCr)               'evtl. geöffneten CAN Channel schließen
            Thread.Sleep(50)                            '50ms warten
            SerialPort1.Write("S6" & vbCr)              'RKS CAN auf 500kBit/s 
            SerialPort1.Write("O" & vbCr)               'CAN Channel öffnen
        Catch ex As Exception
            MsgBox("Bitte COM-Port auswählen!")
        End Try
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Close Button
        SerialPort1.Write("C" & vbCr)                   'CAN Channal schließen
        Thread.Sleep(50)                                '50ms warten
        SerialPort1.Close()                             'Serial Port schließen
        Button1.Enabled = True
        Button2.Enabled = False
        TrackBar1.Enabled = False
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        'wenn Trackbar bewegt wird
        If SerialPort1.IsOpen Then                      'abfragen ob Serial Port geöffnet ist

            'Trackbar Value in Drehzahl umrechnen
            valuehex = Hex(TrackBar1.Value * 4)
            If valuehex.Length = 1 Then
                valuehex = "000" & valuehex
            ElseIf valuehex.Length = 2 Then
                valuehex = "00" & valuehex
            ElseIf valuehex.Length = 3 Then
                valuehex = "0" & valuehex
            End If

            x280 = "t28080000" & Mid(valuehex, 3, 4) & Mid(valuehex, 1, 2) & "00000000"     'komplette Can Message zusammenbauen

        End If
        Label3.Text = TrackBar1.Value & " U/min"        'U/min in Label auf Form anzeigen
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If SerialPort1.IsOpen Then                      'abfragen ob Serial Port geöffnet ist
            SerialPort1.Write(x280 & vbCr)              'CAN Message senden
            SerialPort1.DiscardInBuffer()               'Serial Port Eingangpuffer leeren
        End If
    End Sub
End Class
